<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Bank_reconciliation extends CI_Controller {
	function __construct() {
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true){
			$this->session->set_flashdata('response','<div class="alert alert-error">Unauthorised access. Login required.</div>');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->model('furniture_quotation_model');
	}	

	function opening_br() {
		$data['title'] = 'Bank Reconciliation (Opening)';
		$data['data'] = NUll;
		$data['bank_list'] = $this->crud_model->get_list2('ledger_code','ledger_name','ledgers',array(''=>'Select'),array('acoount_group_id'=>23,'status'=>1),'ledger_name','asc');
		$this->form_validation->set_rules('fromDate','Date', 'required');
		if($this->form_validation->run() == FALSE) {
			$this->load->view('templates/header');
			$this->load->view('reports/opening_br',$data);
			$this->load->view('templates/footer');
		} else {
			$mysqldate = date('Y-m-d',strtotime($this->input->post('fromDate')));
			$details = $this->input->post('details');
			$transaction = $this->input->post('transaction');
			$led_code = $this->input->post('led_code');
			$tr_type = $this->input->post('tr_type');
			$amount = $this->input->post('amount');
			$insta_no = $this->input->post('insta_no');
			if($this->input->post('insta_date')!=''){
				$insta_date = date('Y-m-d',strtotime($this->input->post('insta_date')));
			} else {
				$insta_date = $mysqldate;
			}

			$brs_data = array(
				'brs_date'    => $mysqldate,
				'transactions'=> $transaction,
				'details'  	  => $details,
				'tr_type'     => $tr_type,
				'amount'	  => $amount,
				'inst_no'  	  => $insta_no,
				'inst_date'   => $insta_date,
				'bank_date'	  => NULL,
				'bank_led_code'=> $led_code,
				'user_id'	  => $this->session->userdata("user_id"),
				'status'      => 1
			);
			$this->db->insert('brs_table', $brs_data);
			redirect('bank_reconciliation/opening_br');
		}
		
	}

	function create() {
		$data['title'] = 'Bank Reconciliation';
		$data['data'] = NUll;
		$data['bank_list'] = $this->crud_model->get_list2('ledger_code','ledger_name','ledgers',array(''=>'Select'),array('acoount_group_id'=>23,'status'=>1),'ledger_name','asc');

		$this->load->view('templates/header');
		$this->load->view('reports/bank_reconciliation',$data);
		$this->load->view('templates/footer');
	}

	function get_balance() {
		$fromDate=date('Y-m-d',strtotime($this->input->post('fromDate')));
		$this->db->select_sum('amount');
		$this->db->from('brs_table');
		$this->db->where('status',1);
		$this->db->where('bank_led_code',$this->input->post('bank_id'));
		$this->db->where('bank_date IS NOT NULL');
		$this->db->where('inst_date >=',$fromDate);
		$query2 = $this->db->get();
		

		$this->db->select('*');
		$this->db->from('brs_table');
		$this->db->where('status',1);
		$this->db->where('bank_led_code',$this->input->post('bank_id'));
		$this->db->where('bank_date IS  NULL');
		$this->db->where('inst_date <=',$fromDate);
		$this->db->order_by('bank_date','asc');
		$query = $this->db->get();
		$balance=0;
		$i=0;
		$html='';
		foreach ($query->result_array() as $key => $value) {
			$balance=$balance+$value['amount'];
			$html.='<tr>';
			$html.='<td>'.$value['inst_no'].'</td>';
			$html.='<td>'.date('M d, Y',strtotime($value['inst_date'])).'</td>';
			$html.='<td>'.$value['transactions'].'</td>';
			$html.='<td>'.$value['tr_type'].'</td>';
			
			if($value['amount']>0){
				$html.='<td>&nbsp;</td>';
				$html.='<td style="text-align: right;" >'.$value['amount'].'</td>';
			} else {
				$html.='<td style="text-align: right;" >'.number_format(($value['amount']*-1),3).'</td>';
				$html.='<td>&nbsp;</td>';
			}
			$html.='<td>';
			$html.='<input type="hidden" name="brs_id[]" class="form-control" value="'.$value['id'].'">';
			$html.='<input type="hidden" name="bank_amount[]" class="form-control bank_amount" value="'.$value['amount'].'">';
			$html.='<input type="hidden" name="inst_date[]" class="form-control inst_date" value="'.date('d-m-Y',strtotime($value['inst_date'])).'">';
			$html.='<input type="text" name="bank_date[]" class="form-control maxDateCurrent bank_date" value="" autocomplete="off" >';
			$html.='</td>';
			$html.='</tr>';
			$i++;
		}
		if($query2->row()!=false){
			$amount=$query2->row()->amount;
		} else {
			$amount=0;
		}
		$data['total'] = $amount;
		$html.='<tr>';
		$html.='<td colspan="4">Balance as per Bank</td>';
		$html.='<td colspan="2" style="text-align: right;"><b class="balance">'.number_format($amount,3).'</b></td>';
		$html.='<td></td>';
		$html.='</tr>';
		$html.='<tr>';
		$html.='<td colspan="4">Amount not reflected in bank</td>';
		$html.='<td colspan="2" style="text-align: right;"><b class="not_reflected">'.$i.'</b></td>';
		$html.='<td></td>';
		$html.='</tr>';
		$data['html']=$html;
		echo json_encode($data);
	}

	function update() {
		$id = $this->input->post('brs_id');
		$bank_date = $this->input->post('bank_date');
		for($i=0;$i<count($id);$i++){
			if($bank_date[$i] != ''){
				$this->db->update('brs_table',array('bank_date'=>date("Y-m-d", strtotime($bank_date[$i]))),array('id'=>$id[$i]));
			}
		}
		redirect('bank_reconciliation/create');
	}
}
?>