<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Credit_note extends CI_Controller {

	public function __construct() {
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','<div class="alert alert-error">Unauthorised access. Login required.</div>');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->library('pagination');
		$this->load->model('furniture_quotation_model');
		$this->load->helper('num_words');
	}


	public function list_credit_note($division_id="NIL",$filter_by="NIL",$filter_value="NIL") {
		$title['headerTitle']="Credit Note List";
		$this->load->library('pagination');
		if (@$this->input->post('division_id')) {
			$division_id =   $this->input->post("division_id");
		}elseif ($division_id != "NIL") {
			$division_id	=	$division_id;
		} else {
			$division_id	= "NIL";
		}
		
		if (@$this->input->post('filter_by')) {
			$filter_by =   $this->input->post("filter_by");
		}elseif ($filter_by != "NIL") {
			$filter_by	=	$filter_by;
		} else {
			$filter_by	= "NIL";
		}
		
		if (@$this->input->post('filter_value')) {
			$filter_value =   $this->input->post("filter_value");
		}elseif ($filter_value != "NIL") {
			$filter_value	=	$filter_value;
		} else {
			$filter_value	= "NIL";
		}
		$config["base_url"] = base_url() . "index.php/Credit_note/list_credit_note/".$division_id."/".$filter_by."/".$filter_value;
        $config["total_rows"] = $this->furniture_quotation_model->cnbbrecord_count($division_id,$filter_by,$filter_value);
        $config['num_links'] = 10;
        $config["per_page"] = 100;
		$config['uri_segment'] =6;
        $this->pagination->initialize($config);
        if ($this->uri->segment(6)) {
            $page = $this->uri->segment(6)*100-100;
            $i=$page+1;
        } else {
            $page = 0;
            $i=1;
        }
		$data['receipts'] = $this->furniture_quotation_model->get_all_credit_notes($config["per_page"], $page,$division_id,$filter_by,$filter_value);
		$data['pagination'] = $this->pagination->create_links();
		//print_r($this->data['receipts']);exit;
		$this->load->view('templates/header',$title);
		$this->load->view('manage/list_credit_note',$data);
		$this->load->view('templates/footer');
	}

	public function index($quotation_id=0) {
		$this->data['receipts'] = $this->furniture_quotation_model->get_all_receipts();
		//print_r($this->data['receipts']);exit;
		$this->load->view('templates/header');
		$this->load->view('manage/receipts',$this->data);
		$this->load->view('templates/footer');
	}
	
	public function create_credit_note(){
		$title['headerTitle']="New Credit Note";
		$data['records'] 		= $this->crud_model->get('voucher_ledger_mapping');
		$data['books_beginning_date']=$this->furniture_quotation_model->books_beginning_date_config();
		$this->load->view('templates/header',$title);
		$this->load->view('manage/create_credit_note',$data);
		$this->load->view('templates/footer');
	}
	
	function search_client_for_receipt() {
		$search_name = trim($this->input->post('filter_division'));
		$search_mob = trim($this->input->post('search_name'));
		
		$or_where=array();
		$like=null;
		if($search_mob !='' && $search_name!='') {
			$where=array('furniture_invoice.quotation_divisionid'=>$search_name);
			$like=array('furniture_invoice.client'=>$search_mob);
		
		}else{
			$where=array('furniture_invoice.quotation_divisionid'=>$search_name);
			$like=array();
		}
		$this->db->distinct();
		$this->db->select('new_client_master.client_id,new_client_master.client_code,new_client_master.client_name,new_client_master.client_address,new_client_master.client_country,new_client_master.client_telephone1,new_client_master.client_telephone2,new_client_master.client_fax,new_client_master.client_email,furniture_invoice.quotation_divisionid');
		$this->db->from('furniture_invoice');
		$this->db->join('new_client_master', 'new_client_master.client_id = furniture_invoice.client_id','inner');
		$this->db->where($where);
		$this->db->where('furniture_invoice.invoice_status', '0'); 
		$this->db->like($like);
		$rs = $this->db->get();
		
		if($rs->num_rows() > 0){
			$records['client_list'] = $rs->result_array();
			if($records['client_list'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('manage/search_clients', $records);
			//$this->load->view('manage/search_result_receipt', $records);
		}
		}
		
		//$records['client_list']=$this->crud_model->get('new_client_master',array(), null,null,null,null,$like, $or_where);
		
	}
	
	function search_client_for_receiptxx() {
		$html='';
		$search_name = trim($this->input->post('filter_division'));
		$search_mob = trim($this->input->post('search_name'));
		$or_where=array();
		$like=null;
		if($search_mob !='' && $search_name!='') {
			$where=array();
			//$where=array('furniture_quotation.quotation_divisionid'=>$search_name);
			$like=array('new_client_master.client_name'=>$search_mob);
		
		}else{
			$where=array();
			//$where=array('furniture_quotation.quotation_divisionid'=>$search_name);
			$like=array();
		}
		
		
		$this->db->distinct();
		$this->db->select('new_client_master.client_id,new_client_master.client_name,new_client_master.client_code,new_client_master.client_address,new_client_master.client_country,new_client_master.client_telephone1,new_client_master.client_telephone2,new_client_master.client_fax,new_client_master.client_email');
		$this->db->from('new_client_master');
		//$this->db->where('invoice_amount','1');
		$this->db->where($where);
		$this->db->like($like);
		$this->db->limit(25);
		$rs = $this->db->get();
		//echo $this->db->last_query().'<br>';
		if($rs->num_rows() > 0){
			$records['client_list'] = $rs->result_array();
			if($records['client_list'] == false ){
				$html.='<li style="color:red;" class="no_result_button" > No Results Found </li>';
				echo $html;
			} else {
				foreach($records['client_list'] as $index=>$client_entry) {
					$html.='<li  tabindex="-1"  value="' .$client_entry['client_id'] .'" ref="' .$search_name .'" data-client_code="' .$client_entry['client_code'] .'" data-client_name="' .$client_entry['client_name'] .'" class="client_buttonxxxxx" >'. $client_entry['client_name'] . '</li>';
			
				}
				echo $html;
			}
		}
	}

	/*$where = '(furniture_invoice.client_id ="'.$client_id.'" AND furniture_invoice.quotation_divisionid ="'.$ref_division.'" AND (furniture_invoice.invoice_amount > furniture_invoice.paid_amount) AND furniture_invoice.invoice_status!="1")';
		//$invoices=$this->furniture_quotation_model->get_outstanding_invoices_new($client_id,$ref_division);
		$this->db->select('*');
		$this->db->from('furniture_invoice');
		$this->db->join('company_division','company_division.division_id=furniture_invoice.quotation_divisionid','inner');
		$this->db->join('new_client_master','new_client_master.client_name=furniture_invoice.client','left');
		$this->db->where($where);
		$this->db->group_by("furniture_invoice.invoice_id");
		$rs = $this->db->get();*/


	/*function get_outstanding_invoices(){
		$client_id = $this->input->post('client');
		$ref_division = $this->input->post('ref_division');
		$invoices=$this->furniture_quotation_model->get_outstanding_invoices_new($client_id,$ref_division);

                if ($invoices != false){
                foreach($invoices as $index =>$invoice){
			$quotation_id = $invoice['quotation_id'];
			//$amount_paid = $this->furniture_quotation_model->get_paid_receipts_total($quotation_id);
			$amount_paid = $invoice['paid_amount'];
                        $invoices[$index]['amount_paid'] =$amount_paid;
						
					
			$invoices[$index]['balance_amount'] =$invoice['invoice_amount']- $amount_paid;
		
		}
                }
		$records['invoices'] = $invoices;
		if($records['invoices'] == false ){
			echo '<label style="color:red; font-size:14.5px;">No Invoice List Available..!</label>';
		} else {
			$records=html_escape($records);
			$this->load->view('manage/search_result_receipt', $records);

		}
	}*/

	function get_outstanding_invoices(){
		$client_id = $this->input->post('client');
		$ref_division = $this->input->post('ref_division');
		$invoices=$this->furniture_quotation_model->get_outstanding_invoices_new2($client_id,$ref_division);

        if ($invoices != false){
				foreach($invoices as $index =>$invoice){
				//$quotation_id = $invoice['quotation_id'];
				//$amount_paid = $this->furniture_quotation_model->get_paid_receipts_total($quotation_id);
				$amount_paid = $invoice['paid_amount'];
				$invoices[$index]['amount_paid'] =$amount_paid;
				$invoices[$index]['balance_amount'] =$invoice['invoice_amount']- $amount_paid;
			}
        }
		
		$records['invoices'] = $invoices;
		//if($records['invoices'] == false ){
		//	echo '<label style="color:red; font-size:14.5px;">No Invoice List Available..!</label>';
		//} else {
			$records=html_escape($records);
			$this->load->view('manage/search_result_credit_note', $records);
		//}
	}

	function get_confirmed_quotations(){
		$client_id = $this->input->post('client_id');
		//$invoices = $this->furniture_quotation_model->get_outstanding_invoices($client_id);
		$invoices = $this->furniture_quotation_model->get_confirmed_quotes ($client_id);
              /*
                $not_included_quotations = array();
                if ($invoices != false ) {
                foreach($invoices as $index =>$invoice){
			if($invoice['invoice_number']){
				array_push($not_included_quotations,$invoice['invoice_id']);
			}
		}
                }
                */
		$confirmed_quotations = $this->furniture_quotation_model->get_confirmed_quotations($client_id,$not_included_quotations);
		if(is_array($confirmed_quotations)){
		foreach($confirmed_quotations as $index =>$invoice){
			$quotation_id = $invoice['id'];
			$amount_paid = $this->furniture_quotation_model->get_paid_receipts_total($quotation_id);
			$confirmed_quotations[$index]['amount_paid'] =$amount_paid;
			$confirmed_quotations[$index]['balance_amount'] =$invoice['quotation_total']- $amount_paid;
		}
		}
		$records['confirmed_quotations'] = $confirmed_quotations;
		//var_dump($records['invoices']); exit;
		if($records['confirmed_quotations'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('manage/receipts_confirmed_quotations', $records);
			
		}
		
	}

	public function save_credit_note(){
		$this->form_validation->set_rules('ledger_code','Ledger', 'required');
		$this->form_validation->set_rules('i_total','Amount', 'required|max_length[100]');
		$this->form_validation->set_rules('clientIdHidden','Client', 'required');
		$this->form_validation->set_rules('client_code','Client', 'required');

		if ($this->form_validation->run() == FALSE) {
			$data['records'] 		= $this->crud_model->get('voucher_ledger_mapping');
			$data['books_beginning_date']=$this->furniture_quotation_model->books_beginning_date_config();
			$this->session->set_flashdata('response',''.validation_errors().'',':old:');
			$this->load->view('templates/header');
			$this->load->view('manage/createReceipt',$data);
			$this->load->view('templates/footer');
		} else {
			
			$this->db->trans_begin();
			$no_of_invoices = $this->input->post('no_of_invoices');	
			$no_of_adv_receipts = $this->input->post('no_of_adv_receipts');	
			
			//echo $no_of_invoices;
			//exit();

			$SQL = "SELECT MAX(credit_note_number)+1 as `new_credit_note_number` FROM credit_note where quotation_divisionid='".$this->input->post('ref_div_id')."';";
			$result = $this->db->query($SQL);
			$data = $result->result_array();
			
			if($data[0]['new_credit_note_number'] != NULL and $data[0]['new_credit_note_number'] != ""){
				$credit_note_no = $data[0]['new_credit_note_number'];
			} else{
				$credit_note_no = 1;
			}

			$ref_div_id	=	$this->input->post('ref_div_id');

			$credit_note_code	=	$this->furniture_quotation_model->get_credit_note_code($ref_div_id,$credit_note_no);
			
			$credit_note_date	=	date( "Y-m-d", strtotime($this->input->post("credit_note_date")));

			$receipt['credit_note_number'] = $credit_note_no;
			$receipt['credit_note_code']   = $credit_note_code;
			$receipt['client_id'] = $this->input->post('clientIdHidden');
			$receipt['quotation_divisionid'] = $this->input->post("ref_div_id");
			$receipt['credit_note_date'] = $credit_note_date;
			$receipt['credit_note_mode'] = $this->input->post("ledger");
			$receipt['led_code'] 		 = $this->input->post("ledger_code");
			$receipt['taxable_type'] 	 = $this->input->post("taxable_type");
			$amount	=	((float)$this->input->post('i_total'));
			$vat=0;
			if($this->input->post("taxable_type")!=='Non Vat'){
				$vat_percentage	= $this->input->post("taxable_type");
				$taxable_amount=$amount/(1+($vat_percentage/100));
				$vat=$taxable_amount*($vat_percentage/100);
				$receipt['taxable_amount'] = round($taxable_amount,3);
				$receipt['tax_amount'] = round($vat,3);
			} else {
				$taxable_amount=$amount;
				$receipt['taxable_amount'] = $amount;
				$receipt['tax_amount'] = 0;
			}
			$receipt['net_amount'] = ((float)$this->input->post('i_total'));
			$receipt['credit_note_reference'] = $this->input->post("ref_number");
			$receipt['credit_note_remarks'] = $this->input->post("remarks");
			$receipt['credit_note_generatedby'] = $this->session->userdata("user_id");
			$receiptdts['invoice_id'] = 0;
			$rcpt = $this->crud_model->insert('credit_note',$receipt);
			$credit_note_id = $this->db->insert_id();

			$xxreceipt_discount=0;

			$xxreceipt_amount=0;

			$total_paying_amount=0;


			for($i=1;$i<=$no_of_invoices;$i++) {
				$total_paying_amount=$total_paying_amount+(float)$this->input->post("current_amount_invoice_".$i);
				//$xxreceipt_amount=$xxreceipt_amount+(float)$this->input->post("current_amount_invoice_".$i);
				$current_amount_invoice ="current_amount_invoice_".$i;
				$amount = $this->input->post($current_amount_invoice);
				$nbbbamount = $this->input->post($current_amount_invoice)+(float)$this->input->post("receipt_discount_".$i);
				$new_current_bal_amount_invoice ="current_bal_amount_invoice_".$i;
				$bal_amount = $this->input->post($new_current_bal_amount_invoice);
				$invoice_id ="invoice_id_".$i;
				$invid = $this->input->post($invoice_id);
				$new_receipt_tick ="new_receipt_tick_".$i;
				$new_receipt_tick = $this->input->post($new_receipt_tick);
				$sm_id_i =$this->input->post("sm_id_".$i);
				if($amount!="" && $amount!="0"){
					$division_id=$this->input->post('ref_div_id');
					$div_data = $this->db->query("SELECT * FROM `company_division` WHERE division_id='$division_id' ");
					$division_code=$div_data->row()->division_code;  

					$cust_bill_allocations_data = array(
						'customer_code' => $this->input->post('client_code'),
						'bill_id'       => $invid,
						'trn_no'        => $credit_note_code,
						'bill_date'     => $credit_note_date,
						'bill_amt'      => -((float)$nbbbamount),
						'bill_os_amount'=> -((float)$nbbbamount),
						'bill_type'     => 'Credit Note',
						'division_id'   => $division_id,
						'sm_id'   		=> $sm_id_i,
						'trn_type'      => 'Credit Note'
					);
					$this->db->insert('cust_bill_allocations',$cust_bill_allocations_data);
				}
					
			}
			if($credit_note_id){
				
				if($this->input->post('advance_payment')!='' && $this->input->post('advance_payment')!="0" && $this->input->post('advance_payment')!="0.000"){
					$cust_bill_allocations_data = array(
						'customer_code' => $this->input->post('client_code'),
						'bill_id'       => $credit_note_code,
						'trn_no'        => $credit_note_code,
						'bill_date'     => $credit_note_date,
						'bill_amt'      => -((float)$this->input->post('advance_payment')),
						'bill_os_amount'=> -((float)$this->input->post('advance_payment')),
						'bill_type'     => 'Credit Note',
						'sm_id'   		=> $this->session->userdata("user_id"),
						'division_id'   => $division_id,
						'trn_type'      => 'Unallocated'
					);
						
					$this->db->insert('cust_bill_allocations',$cust_bill_allocations_data);
				} 

				if($this->input->post('client_code')!=''){
					//$xxreceipt_amount	=	$total_paying_amount+(float)$this->input->post('advance_payment');
					$xxreceipt_amount	=	$total_paying_amount;
					$this->db->where("vch_no",$credit_note_code);
					$this->db->where("vch_type",'Credit Note');
					$this->db->delete('accounts');
					$accounts_data = array(
						'vch_type' 	  => 'Credit Note',
						'vch_no'  	  => $credit_note_code,
						'vch_date'    => $credit_note_date,
						'vch_ref'     => '',
						'ledger_code' => $this->input->post('client_code'),
						'rev_ledger_code' => $this->input->post('ledger_code'),
						'cc_code' 	  => 1,
						'div_code' 	  => 1,
						'ledger_amount'=> -(float)$xxreceipt_amount,
						'ledger_narration'=> $this->input->post('remarks'),
						'vch_narration'=> 'Auto entry from Credit Note No '.$credit_note_code,
						'user_id' 	  => $this->session->userdata("user_id"),
						'status'      => 1
					);
					$this->db->insert('accounts', $accounts_data);
				}

				if($this->input->post('i_total')!==''){
					$accounts_data = array(
						'vch_type' 	  => 'Credit Note',
						'vch_no'  	  => $credit_note_code,
						'vch_date'    => $credit_note_date,
						'vch_ref'     => '',
						'ledger_code' => $this->input->post('ledger_code'),
						'rev_ledger_code' => $this->input->post('client_code'),
						'cc_code' 	  => 1,
						'div_code' 	  => 1,
						'ledger_amount'=> $taxable_amount,
						'ledger_narration'=> $this->input->post('remarks'),
						'vch_narration'=> 'Auto entry from Credit Note No '.$credit_note_code,
						'user_id' 	  => $this->session->userdata("user_id"),
						'status'      => 1
					);
					$this->db->insert('accounts', $accounts_data);

					if($vat>0){
						$accounts_data2 = array(
							'vch_type' 	  => 'Credit Note',
							'vch_no'  	  => $credit_note_code,
							'vch_date'    => $credit_note_date,
							'vch_ref'     => '',
							'ledger_code' => 'V0001',
							'rev_ledger_code' => $this->input->post('client_code'),
							'cc_code' 	  => 1,
							'div_code' 	  => 1,
							'ledger_amount'=> round($vat,3),
							'ledger_narration'=> $this->input->post('remarks'),
							'vch_narration'=> 'Auto entry from Credit Note No '.$credit_note_code,
							'user_id' 	  => $this->session->userdata("user_id"),
							'status'      => 1
						);
						$this->db->insert('accounts', $accounts_data2);
					}
				}
			}

			$log_data=array(
				'trans_no'  	=>  $credit_note_code,
				'trans_type'  	=>  'Credit Note',
				'trans_op'  	=>  'Create',
				'trans_user_id' =>  $this->session->userdata('user_id')
			);
			$log_for_transactions=$this->crud_model->insert('log_for_transactions',$log_data);

			if ($this->db->trans_status() === FALSE) {
				$this->db->trans_rollback();
				$this->session->set_flashdata('response', 'Something Wrong, Please Try Again...');	
				redirect('Credit_note/list_credit_note');
			} else {
				$this->db->trans_commit();
				$this->session->set_flashdata('success', 'New Credit Note Created...');	
				redirect('Credit_note/list_credit_note');
		 	}
		}
	}

	
	function view1($quotation_id,$receipt_no,$quotation_divisionid,$type){

		$where= array('receipt_number'=>$receipt_no);
		$data['records'] = $this->furniture_quotation_model->get_credit_note_details($receipt_no,$quotation_id,$quotation_divisionid);
		$data['receipt_inv'] = $this->furniture_quotation_model->get_all_credit_notes_invdetails($receipt_no,$quotation_id,$quotation_divisionid);
		
		$data['credit_note_code'] = $data['records'][0]['credit_note_code'];
		$data['credit_note_number'] = $data['records'][0]['credit_note_number'];
		$data['division_code'] = $data['records'][0]['division_code'];
		$data['currency_code'] = $data['records'][0]['currency_code'];
		$data['credit_note_date'] = $data['records'][0]['credit_note_date'];
		$data['credit_note_mode'] = $data['records'][0]['credit_note_mode'];
		$data['ledger_name'] = $data['records'][0]['ledger_name'];
		$data['net_amount'] = $data['records'][0]['net_amount'];
		$data['taxable_amount'] = $data['records'][0]['taxable_amount'];
		$data['credit_note_reference'] = $data['records'][0]['credit_note_reference'];
		$data['tax_amount'] = $data['records'][0]['tax_amount'];
		$data['currency_name1'] = $data['records'][0]['currency_name'];
		$data['credit_note_status'] = $data['records'][0]['credit_note_status'];
		$data['taxable_type'] = $data['records'][0]['taxable_type'];
		$data['credit_note_remarks'] = $data['records'][0]['credit_note_remarks'];
		$data['division_id'] = $data['records'][0]['division_id'];
		$data['division_code'] = $data['records'][0]['division_code'];
		$data['logo_filename'] = $data['records'][0]['logo_filename'];
		$data['client_code'] = $data['records'][0]['client_code'];

		$temp = $data['records'][0]['credit_note_generatedby'];
		$where= array('user_id'=>$temp);
		$generated_by_user = $this->crud_model->get('users',$where);
		$data["generated_by"] = $generated_by_user[0]['user_name'];


		$data["received_from"] = $data['records'][0]['client_name'];

		$data['net_amount'] = $data['records'][0]["net_amount"];

		
		$query = $this->db->get('company_details');  
		$data['company_details'] = $query->row();
		foreach ($query->result() as $row){
			$company_email_name =  $row->company_name;
		}
		
		if($type=="pdf"){
			$records['print_type'] = "pdf_print_type";
			//$this->load->helper(array('dompdf', 'file'));
			$mpdf = new \Mpdf\Mpdf();
			$html = $this->load->view('manage/print_credit_note', $data, true);
			//echo $html;
			if($data['records'][0]['credit_note_status']==0){
				$mpdf->SetWatermarkText('Cancelled');
				$mpdf->showWatermarkText = true;
			}
			$mpdf->WriteHTML($html);
			$file_name	=	'Credit Note Voucher - '.$data['records'][0]['credit_note_code'].'.pdf';
			$mpdf->Output($file_name, 'I');
		}
	
	}
	
	
	public function cancel_credit_note($credit_note_number,$quotation_divisionid,$receipt_id,$credit_note_code){
		$this->db->where('credit_note_number',$credit_note_number);
		$this->db->where('quotation_divisionid',$quotation_divisionid);
		$data = array(
			'credit_note_status' => 0,
			'credit_note_cancelledby' => $this->session->userdata('user_name'),
			'credit_note_cancelled_date' => date('Y-m-d h:m:s')
		);
		$receipt_cancel	= $this->db->update('credit_note', $data);

		$this->db->where('trn_no',$credit_note_code);
		$data1 = array(
			'status' => 0
		);
		$this->db->update('cust_bill_allocations', $data1);

		$this->db->where('vch_no',$credit_note_code);
		$data1 = array(
			'status' => 0
		);
		$this->db->update('accounts', $data1);
		
		$log_data=array(
			'trans_no'  	=>  $credit_note_code,
			'trans_type'  	=>  'Credit Note',
			'trans_op'  	=>  'Delete',
			'trans_user_id' =>  $this->session->userdata('user_id')

		);
		$log_for_transactions=$this->crud_model->insert('log_for_transactions',$log_data);
		
		if($receipt_cancel){
			$this->session->set_flashdata('response', 'Credit Note Cancelled...');
		}else{
			$this->session->set_flashdata('response', 'Something Wrong.Try Again...');
		}
		redirect('Credit_note/list_credit_note');
	}
	public function search_ledger() {
		$client	=	$this->input->post('client');
		$today	=	date("Y-m-d");
		$html	='';
		$sql="";
		$clients = explode(" ", trim($client));
		for($i=0;$i<count($clients);$i++) {
			$r	= $clients[$i];
			$sql.=" and ledger_name LIKE '%$r%' ";
		}
		$client_contact_data = $this->db->query("SELECT * FROM `ledgers` where (acoount_group_id=5 OR acoount_group_id=8 OR acoount_group_id=19) and `ledger_name` like '$client%'   union (SELECT * FROM `ledgers` where (acoount_group_id=5 OR acoount_group_id=8 OR acoount_group_id=19) and  `ledger_id` not in (SELECT `ledger_id` FROM `ledgers` where (acoount_group_id=5 OR acoount_group_id=8 OR acoount_group_id=19) and `ledger_name` like '$client%' ) ".$sql." order by ledger_name) limit 25 ");
		$n=1;
		if(count($client_contact_data->result_array())>0){
			$html ='';
			foreach ($client_contact_data->result_array() as $client_contact_datas){
				$html.='<li value="' .$client_contact_datas['ledger_id'].'" class="ledger_button" tabindex="'.$n++.'" ><input type="hidden" class="ledger_name" value="'.$client_contact_datas['ledger_name'].'" /><input type="hidden" class="pop_ledger_code" value="'.$client_contact_datas['ledger_code'].'" />'.$client_contact_datas['ledger_name'].'</li>';
			}
		} else {
			$html.='<li style="color:red;" class="no_result_button" > No Results Found </li>';
		}
		print $html;
	}
}

?>