<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Credit_note extends CI_Controller {
	public function __construct() {
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','<div class="alert alert-error">Unauthorised access. Login required.</div>');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->library('pagination');
		$this->load->model('furniture_quotation_model');
		$this->load->helper('num_words');
	}

	public function index($quotation_id=0) {
		$this->data['receipts'] = $this->furniture_quotation_model->get_all_credit_notes();
		//print_r($this->data['receipts']);exit;
		$this->load->view('templates/header');
		$this->load->view('manage/credit_notes',$this->data);
		$this->load->view('templates/footer');
	}
	
	public function create_credit_note(){
	
		$this->load->view('templates/header');
		$this->load->view('manage/create_credit_note');
		$this->load->view('templates/footer');
	}
	
	function search_client_for_receipt() {
		$search_name = trim($this->input->post('filter_division'));
		$search_mob = trim($this->input->post('search_name'));
		
		$or_where=array();
		$like=null;
		if($search_mob !='' && $search_name!='') {
			$where=array('furniture_invoice.quotation_divisionid'=>$search_name);
			$like=array('furniture_invoice.client'=>$search_mob);
		
		}else{
			$where=array('furniture_invoice.quotation_divisionid'=>$search_name);
			$like=array();
		}
		$this->db->distinct();
		$this->db->select('new_client_master.client_id,new_client_master.client_name,new_client_master.client_address,new_client_master.client_country,new_client_master.client_telephone1,new_client_master.client_telephone2,new_client_master.client_fax,new_client_master.client_email,furniture_invoice.quotation_divisionid');
		$this->db->from('furniture_invoice');
		$this->db->join('new_client_master', 'new_client_master.client_id = furniture_invoice.client_id','inner');
		$this->db->where($where);
		$this->db->where('furniture_invoice.invoice_status', '0'); 
		$this->db->like($like);
		$rs = $this->db->get();
		if($rs->num_rows() > 0){
			$records['client_list'] = $rs->result_array();
			if($records['client_list'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('manage/search_clients', $records);
			//$this->load->view('manage/search_result_receipt', $records);
		}
		}
		
		//$records['client_list']=$this->crud_model->get('new_client_master',array(), null,null,null,null,$like, $or_where);
		
	
		
		
	}


	function get_outstanding_invoices(){
		$client_id = $this->input->post('client');
		$ref_division = $this->input->post('ref_division');
		$invoices=$this->furniture_quotation_model->get_outstanding_invoices_new($client_id,$ref_division);

                if ($invoices != false){
                foreach($invoices as $index =>$invoice){
			$quotation_id = $invoice['quotation_id'];
			//$amount_paid = $this->furniture_quotation_model->get_paid_receipts_total($quotation_id);
			$amount_paid = $invoice['paid_amount'];
                        $invoices[$index]['amount_paid'] =$amount_paid;
						
					
			$invoices[$index]['balance_amount'] =$invoice['invoice_amount']- $amount_paid;
		
		}
                }
		$records['invoices'] = $invoices;
		if($records['invoices'] == false ){
			echo '<label style="color:red; font-size:14.5px;">No Invoice List Available..!</label>';
		} else {
			$records=html_escape($records);
			$this->load->view('manage/search_result_credit_note', $records);

		}
	}

	function get_confirmed_quotations(){
		$client_id = $this->input->post('client_id');
		//$invoices = $this->furniture_quotation_model->get_outstanding_invoices($client_id);
		$invoices = $this->furniture_quotation_model->get_confirmed_quotes ($client_id);
              /*
                $not_included_quotations = array();
                if ($invoices != false ) {
                foreach($invoices as $index =>$invoice){
			if($invoice['invoice_number']){
				array_push($not_included_quotations,$invoice['invoice_id']);
			}
		}
                }
                */
		$confirmed_quotations = $this->furniture_quotation_model->get_confirmed_quotations($client_id,$not_included_quotations);
		if(is_array($confirmed_quotations)){
		foreach($confirmed_quotations as $index =>$invoice){
			$quotation_id = $invoice['id'];
			$amount_paid = $this->furniture_quotation_model->get_paid_receipts_total($quotation_id);
			$confirmed_quotations[$index]['amount_paid'] =$amount_paid;
			$confirmed_quotations[$index]['balance_amount'] =$invoice['quotation_total']- $amount_paid;
		}
		}
		$records['confirmed_quotations'] = $confirmed_quotations;
		//var_dump($records['invoices']); exit;
		if($records['confirmed_quotations'] == false ){
			echo 0;
		} else {
			$records=html_escape($records);
			$this->load->view('manage/receipts_confirmed_quotations', $records);
			
		}
		
	}
	public function save_credit_note_new(){
		$no_of_invoices = $this->input->post('no_of_invoices');		
		$SQL = "SELECT MAX(credit_note_number)+1 as `new_credit_note_number` FROM credit_note where quotation_divisionid='".$this->input->post('ref_div_id')."';";
		$result = $this->db->query($SQL);
		$data = $result->result_array();
		
		if($data[0]['new_credit_note_number'] != NULL and $data[0]['new_credit_note_number'] != ""){
			$new_credit_note_no = $data[0]['new_credit_note_number'];
		} else{
			$new_credit_note_no = 101;
		}
				
		//$receipt_no = $this->furniture_quotation_model->get_new_receipt_number();
		//$amount = $this->input->post($current_amount_invoice);
			for($i=1;$i<=$no_of_invoices;$i++)
			{
				$current_amount_invoice ="current_amount_invoice_".$i;
				$amount = $this->input->post($current_amount_invoice);
				$new_current_bal_amount_invoice ="current_bal_amount_invoice_".$i;
				$bal_amount = $this->input->post($new_current_bal_amount_invoice);
				$invoice_id ="invoice_id_".$i;
				$invid = $this->input->post($invoice_id);
				$new_receipt_tick ="new_receipt_tick_".$i;
				$new_receipt_tick = $this->input->post($new_receipt_tick);
				if($amount!="" && $amount!="0"){
						//$receipt['quotation_id'] = $quotation_id;
						$receipt['credit_note_number'] = $new_credit_note_no;
						$receipt['quotation_divisionid'] = $this->input->post("ref_div_id");
						$receipt['credit_note_date'] = date( "Y-m-d", strtotime($this->input->post("receipt_date")));
						$receipt['credit_note_mode'] = $this->input->post("credit_note_type");
						$receipt['taxable_type'] = $this->input->post("taxable_type");
						if($this->input->post("taxable_type")!=='Non Vat'){
							$vat_percentage	= $this->input->post("taxable_type");
							$taxable_amount=$amount/1.05;
							$vat=$taxable_amount*.05;
							$receipt['taxable_amount'] = round($taxable_amount,3);
							$receipt['tax_amount'] = round($vat,3);
						} else {
							$receipt['taxable_amount'] = $amount;
							$receipt['tax_amount'] = 0;
						}
						$receipt['net_amount'] = $amount;
						//$receipt['receipt_discount'] = $this->input->post("receipt_discount_".$i);
						//$receipt['balance_amount'] = $bal_amount;
						$receipt['credit_note_reference'] = $this->input->post("credit_note_reference");
						//$receipt['receipt_bankname'] = $this->input->post("bank_name");
						$receipt['credit_note_remarks'] = $this->input->post("remarks");
						$receipt['credit_note_generatedby'] = $this->session->userdata("user_id");
						$receipt['invoice_id'] = $invid;
						
						//$this->furniture_quotation_model->set_receipt_id($quotation_id);
						//$generated_receipt_id = $this->session->userdata("furniture_receipt_id");
						//$where= array('receipt_id'=>$generated_receipt_id);
						$inv = $this->crud_model->insert('credit_note',$receipt);
						if($inv){
							$total_credit_note_amount = $this->furniture_quotation_model->get_credit_amount_for_invoice($invid);
							//$receipt_discount = $this->furniture_quotation_model->get_receipt_discount_for_invoice($invid);
							$invoiceWhere = array('invoice_id' => $invid);
							$invoiceData = array('total_credit_note_amount' => $total_credit_note_amount+$amount);
							$invupdate = $this->crud_model->update('furniture_invoice',$invoiceData,$invoiceWhere);

							$division_id=$this->input->post('ref_div_id');
							$div_data = $this->db->query("SELECT * FROM `company_division` WHERE division_id='$division_id' ");
							$division_code=$div_data->row()->division_code;  

							$cust_bill_allocations_data = array(
								'customer_code' => $this->input->post('clientIdHidden'),
								'bill_id'         => $invid,
								'trn_no'       => $division_code.'-'.$new_credit_note_no,
								'bill_date'         => date("Y-m-d h:m:s"),
								'bill_amt'       => -((float)$amount),
								'bill_os_amount'     => -((float)$amount),
								'bill_type'       => 'Credit Note',
								'trn_type'               =>  'Credit Note'
								);
								
								$this->db->insert('cust_bill_allocations',$cust_bill_allocations_data);

						}
				}
					
			}
		/*if($inv){
		$SQLRECEIPT = "SELECT MAX(receipt_id) as `receipt_id` FROM furniture_receipts;";
		$receipt_result = $this->db->query($SQLRECEIPT);
		$receipt_details = $receipt_result->result_array();
		$receipt_id = $receipt_details[0]['receipt_id'];
		
		// MAILING ....

				$INVOICESQL = "SELECT company_division.division_code AS division_name,company_division.currency_code AS currency_name,furniture_invoice.client AS client,furniture_receipts.receipt_number,furniture_receipts.receipt_amount,furniture_receipts.quotation_divisionid FROM furniture_receipts JOIN furniture_invoice ON furniture_invoice.invoice_id=furniture_receipts.invoice_id JOIN company_division ON company_division.division_id=furniture_invoice.quotation_divisionid WHERE furniture_receipts.receipt_id=".$receipt_id;
				$invoice_result = $this->db->query($INVOICESQL);
				$invoice_details = $invoice_result->result_array();
				$this->db->select('*');
				$this->db->from('emails'); 
				$query_email = $this->db->get();
				$records_email=$query_email->result_array();

				$links =   site_url('furniture/furniture_receipt/view1/'.$receipt_id.'/'.$invoice_details[0]['receipt_number'].'/'.$invoice_details[0]['quotation_divisionid'].'/normal');
				/*	email notification start	
				$this->load->library('tw_email');
				// send mail code
				$from 		= ADMIN_MAIL;
				$fromname 	= 'Q-Pro Admin';
				$to 		= @$records_email[0]['receipt'];
				$subject 	= 'Q-Pro - Receipt for '.$invoice_details[0]['client'].'('.$invoice_details[0]['division_name'].' - '.$invoice_details[0]['receipt_number'].') is created';
				$message 	= '
				<table>
					<tr>
						<td>Receipt No.</td>
						<td>:</td>
						<td><a href='.$links.'>'.$invoice_details[0]['division_name'].' - '.$invoice_details[0]['receipt_number'].'</a></td>

					</tr>
					<tr>
						<td>Client</td>
						<td>:</td>
						<td>'.$invoice_details[0]['client'].'</td>
					</tr>
					<tr>
						<td>Receipt Amount</td>
						<td>:</td>
						<td>'.$invoice_details[0]['currency_name'].'. '.number_format( $invoice_details[0]['receipt_amount'],2).'</td>
					</tr>
				</table>';

				$this->tw_email->send($from,$fromname,$to,$subject,$message);

				/*	email notification end		*/
		
		$this->session->set_flashdata('response', 'New Credit Note Created...');	
		redirect('credit_note');
	}
	public function save_receipt(){
		
		$no_of_invoices = $this->input->post('no_of_invoices');
		$no_of_confirmed_quotations = $this->input->post('no_of_confirmed_quotations');
		
		$this->form_validation->set_message('amount_check','Amount is invalid or greater than balance');
		$this->form_validation->set_rules('remarks', 'Remarks', 'max_length[48]');
		
		if($this->input->post("payment_modes") != "Cash"){
			$this->form_validation->set_rules('ref_number', 'Reference Number', 'max_length[20]');
			$this->form_validation->set_rules('bank_name', 'Bank Name', 'required|max_length[100]');
		}
		
		if ($this->form_validation->run() == TRUE){
			$receipt_no = $this->furniture_quotation_model->get_new_receipt_number();
		
			for($i=1;$i<=$no_of_invoices;$i++)
			{
				$quotation_id_name = "quotation_id_invoices_".$i;
				$new_receipt_tick ="new_receipt_tick_".$i;
				$quotation_id = $this->input->post($quotation_id_name);
				$receipt_chk = $this->input->post($new_receipt_tick);
				
				if($receipt_chk){
					$current_amount_invoice ="current_amount_invoice_".$i;
					$amount = $this->input->post($current_amount_invoice);
					$this->form_validation->set_rules($current_amount_invoice,'Receipt Amount','required|max_length[20]|numeric|callback_amount_check['.$amount.','.$quotation_id.']');
					if ($this->form_validation->run() == TRUE){
						$receipt['quotation_id'] = $quotation_id;
						$receipt['receipt_number'] = $receipt_no;
						$receipt['receipt_date'] = date("Y-m-d h:m:s");
						$receipt['receipt_mode'] = $this->input->post("payment_modes");
						$receipt['receipt_amount'] = $current_amount_invoice;
						$receipt['receipt_reference'] = $this->input->post("ref_number");
						$receipt['receipt_bankname'] = $this->input->post("bank_name");
						$receipt['receipt_remarks'] = $this->input->post("remarks");
						$receipt['receipt_generatedby'] = $this->session->userdata("user_id");
						
						$this->furniture_quotation_model->set_receipt_id($quotation_id);
						$generated_receipt_id = $this->session->userdata("furniture_receipt_id");
						$where= array('receipt_id'=>$generated_receipt_id);
						$this->crud_model->insert('furniture_receipts',$receipt);
					}else{
						echo "Validation Error2";
					}		
				}
				$paid_amount = $this->furniture_quotation_model->get_paid_amount_for_quotation($quotation_id);
				$invoiceWhere = array('quotation_id' => $quotation_id);
				$invoiceData = array('paid_amount' => $paid_amount + $current_amount_invoice);
				$this->crud_model->update('furniture_invoice',$invoiceData,$invoiceWhere);
				
			}
			echo "fgdf".$no_of_confirmed_quotations;
			for($i=1;$i<=$no_of_confirmed_quotations;$i++){
				$quotation_id_name = "quotation_id_quote_".$i;
				$new_receipt_tick ="new_receipt_tick_quote_".$i;
				$quotation_id = $this->input->post($quotation_id_name);
				$receipt_chk = $this->input->post($new_receipt_tick);
				
				if($receipt_chk){
					$current_amount_invoice ="current_amount_confirmed_quote_".$i;
					$amount = $this->input->post($current_amount_invoice);
					$this->form_validation->set_rules($current_amount_invoice,'Receipt Amount','required|max_length[20]|numeric|callback_amount_check['.$amount.','.$quotation_id.']');
					if ($this->form_validation->run() == TRUE){
						$receipt['quotation_id'] = $quotation_id;
						$receipt['receipt_number'] = $receipt_no;
						$receipt['receipt_date'] = date('Y-m-d h:m:s');
						$receipt['receipt_mode'] = $this->input->post("payment_modes");
						$receipt['receipt_amount'] = $this->input->post($current_amount_invoice);
						$receipt['receipt_reference'] = $this->input->post("ref_number");
						$receipt['receipt_bankname'] = $this->input->post("bank_name");
						$receipt['receipt_remarks'] = $this->input->post("remarks");
						$receipt['receipt_generatedby'] = $this->session->userdata("user_id");
						
						$this->furniture_quotation_model->set_receipt_id($quotation_id);
						$generated_receipt_id = $this->session->userdata("furniture_receipt_id");
						$where= array('receipt_id'=>$generated_receipt_id);
						$this->crud_model->insert('furniture_receipts',$receipt);
					}else{
						echo "Validation Error2";
					}
				}
			}
		}else{
			echo "Validation Error1";
		}
		
		redirect('receipt');
	}
	
	function amount_check($amount,$quotation_id){
		//$quotation_id =$this->session->userdata('receipt_quotation_id');
		$where1= array('quotation_id'=>$quotation_id);
		$data['records'] = $this->crud_model->get('furniture_receipts',$where1);
		$receipt_total = 0;
			if($data['records'] != false) {
				foreach ($data['records'] as $recrd){
					if($recrd['receipt_status'] != 0){
						$receipt_total += $recrd['receipt_amount'];
					}
				}
			}
		$quotation_details = $this->furniture_quotation_model->get_full_quotation_details($quotation_id);
		
		$data['balance'] = $quotation_details['quotation_net_total'] - $receipt_total;
		
		if($data['balance']< $amount){
			return false;
		} else{
			if($this->input->post('receipt_amount')<=0){
				return false;
			} else{
				return true;
			}
		}
	}
	
	function filter_receipts(){
	
	}
	
	
public function cancel_credit_note($receipt_number,$quotation_divisionid,$receipt_id){
			$this->db->where('credit_note_number',$receipt_number);
			$this->db->where('quotation_divisionid',$quotation_divisionid);
				 $data = array(
					'credit_note_status' => 0,
					'credit_note_cancelledby' => $this->session->userdata('user_name'),
					'credit_note_cancelled_date' => date('Y-m-d h:m:s')
				);
			$receipt_cancel	= $this->db->update('credit_note', $data);
				
			$this->db->select('net_amount,invoice_id');
			$this->db->from('credit_note');
			$this->db->where('credit_note.credit_note_number', $receipt_number);
			$this->db->where('credit_note.quotation_divisionid', $quotation_divisionid); 
			$query = $this->db->get();
			if ($query->num_rows() > 0) {
			foreach ($query->result() as $row) {
				
			$credit_note 			 = $this->furniture_quotation_model->get_credit_amount_for_invoice_nb($row->invoice_id);
			 $this->db->where('invoice_id',$row->invoice_id);
				 $invdata = array(
					'total_credit_note_amount' 		=> $credit_note
				);
					$this->db->update('furniture_invoice', $invdata);
		 	}
			}
			//}
			//break;
			
			
			if($receipt_cancel){
			
			$this->session->set_flashdata('response', 'Credit Note Cancelled...');
			}else{
			$this->session->set_flashdata('response', 'Something Wrong.Try Again...');
			}
		    redirect('credit_note');
	}
	

	function view1($quotation_id,$receipt_no,$quotation_divisionid,$type=""){

		$records = $this->furniture_quotation_model->get_full_quotation_details($quotation_id,'unique');
		$currency_code = $records['currency_code'];

		$where= array('receipt_number'=>$receipt_no);
		$data['records'] = $this->furniture_quotation_model->get_credit_note_details($receipt_no,$quotation_id,$quotation_divisionid);
		$data['receipt_inv'] = $this->furniture_quotation_model->get_all_credit_notes_invdetails($receipt_no,$quotation_id,$quotation_divisionid);
		$data['base_url'] = base_url();

		$data['logos_url'] = array();
		$logos_id = explode(",",$records['quotation_logos']);
		/*foreach($logos_id as $key=>$logo_id) {
			$where = array('logo_id' => $logo_id);
			$logo = $this->crud_model->get('logos',$where);
			if($logo[0]['logo_filename']){
				array_push($data['logos_url'], $logo[0]['logo_filename']);
			}
		}*/

		$this->db->select('user_email_id,client_email,quotation_logos');    
					$this->db->from('credit_note');
					$this->db->where('credit_note.credit_note_id',$quotation_id);
					$this->db->join('furniture_invoice', 'credit_note.invoice_id = furniture_invoice.invoice_id');
					$this->db->join('furniture_quotation', 'furniture_invoice.quotation_id = furniture_quotation.id','left');
					$this->db->join('new_client_master', 'furniture_invoice.client_id = new_client_master.client_id');
					$this->db->join('users', 'furniture_invoice.created_id = users.user_id');
					$query_val = $this->db->get(); 
					
						foreach ($query_val->result() as $row)
							{
								$user_email_id =  $row->user_email_id;
								$client_email =  $row->client_email;
								$quotation_logos =  $row->quotation_logos;
							}
							if(isset($quotation_logos)){
				$logos_id = explode(",",$quotation_logos);}
		foreach($logos_id as $key=>$logo_id) {
			$where = array('logo_id' => $logo_id);
			$logo = $this->crud_model->get('logos',$where);
			if($logo==true){
				array_push($data['logos_url'], "images/logos/".$logo[0]['logo_filename']);
			}else{
				array_push($data['logos_url'], "images/company_division/".$data['records'][0]['logo_filename']);
			}
		}
		
		//$where = array('quotation_id'=>$quotation_id);
		$generated_receipts 	= $this->furniture_quotation_model->get_generated_receipts($quotation_id);
		$data['amount_paid'] 	= $generated_receipts[0]['rcpt_amount'] ;
		$data['balance'] 		= $records['quotation_net_total'] - $generated_receipts[0]['rcpt_amount'];

					/*
		if($data['records'][0]['receipt_status']) {
			$receipt_total = 0;
			if($generated_receipts != false) {
				foreach ($generated_receipts as $receipt){
					if($receipt['receipt_status'] != 0 and $receipt['receipt_no'] <= $data['records'][0]['receipt_id']){
						$receipt_total += $receipt['receipt_amount'];
					}
				}
			}
			$data['balance'] = $records['quotation_net_total'] - $receipt_total;
			$data['amount_paid']  = $receipt_total;
		} else {
			$data['cancel_flag'] = 1;
		} */


		$data['credit_note_number'] 	= $data['records'][0]['credit_note_number'];
		$data['division_code'] 		= $data['records'][0]['division_code'];
		$data['currency_code'] 		= $data['records'][0]['currency_code'];
		$data['credit_note_date'] 		= $data['records'][0]['credit_note_date'];
		$data['credit_note_mode'] 		= $data['records'][0]['credit_note_mode'];
		$data['net_amount'] 	= $data['records'][0]['net_amount'];
		$data['receipt_discount'] 	= '';
		$data['credit_note_remarks'] 	= $data['records'][0]['credit_note_remarks'];
		$data['credit_note_reference'] 	= $data['records'][0]['credit_note_reference'];
		$data['currency_name1'] 	= $data['records'][0]['currency_name'];
		$data['credit_note_status'] 	= $data['records'][0]['credit_note_status'];
		$data['division_id'] 		= $data['records'][0]['division_id'];
		$data['taxable_type'] 		= $data['records'][0]['taxable_type'];
		$data['taxable_amount'] 		= $data['records'][0]['taxable_amount'];
		$data['tax_amount'] 		= $data['records'][0]['tax_amount'];
		$data['cheque_date'] 		= '';

		$data['quotation_number'] 		= $records['division_code'].'-'.$records['quotation_number'].'-'.$records['quotation_revisionnumber'];
		$data['quotation_net_total'] 	= $records['quotation_net_total'];



		$temp = $data['records'][0]['credit_note_generatedby'];
		$where= array('user_id'=>$temp);
		$generated_by_user = $this->crud_model->get('users',$where);
		$data["generated_by"] = $generated_by_user[0]['user_name'];


		$data["received_from"] = $data['records'][0]['client'];
		$data["receipt_code"] = $records["division_code"];
		//$data["currency_code"] = $currency_code;

		$data['net_amount'] = $data['records'][0]["net_amount"];

		$data['currency_name'] = $records['currency_name'];
		$data['quotation_id'] = $quotation_id;



		//$this->load->view('furniture/quotations/furniture_receipt/view_receipt', $data);
		
		$query = $this->db->get('company_details');  
		$data['company_details'] = $query->row();
		foreach ($query->result() as $row)
			{
				$company_email_name =  $row->company_name;
			}
		
		if($type=="pdf"){
			$records['print_type'] = "pdf_print_type";
			$this->load->helper(array('dompdf', 'file'));
			$html = $this->load->view('furniture/quotations/furniture_receipt/view_receipt1', $data, true);
			pdf_create($html, 'Receipt_No_'.$data['records'][0]['division_code'].'-'.$data['records'][0]['receipt_number']);
		}else if($type=="normal"){
			$records['print_type'] = "normal_print_type";
			$this->load->view('manage/view_credit_note', $data);
			$this->load->view('furniture/quotations/furniture_receipt/test_print');
			$this->load->view('manage/view_credit_note', $data);
		}
	
	}

		
}

?>