<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Invoices extends CI_Controller {

	public function __construct() {
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','Unauthorised access. Login required.');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->library('pagination');
		$this->load->model('furniture_quotation_model');
		$this->load->helper('num_words');
	}

	public function index($quotation_id=0,$fromDate="NIL",$toDate="NIL",$filter_division='NIL',$client_id='NIL',$filter_value='NIL',$qtnNo='NIL') {
		
		$title['headerTitle']="Invoice List";

		if (@$this->input->post('fromDate')) {
			$date2 = str_replace('/', '-', $this->input->post("fromDate"));
			$fromDate =   date("Y-m-d", strtotime($this->input->post("fromDate")));
		}elseif ($fromDate != "NIL") {
			$fromDate	=	$fromDate;
		} else {
			$fromDate	= 'NIL';
		}
		
		if (@$this->input->post('toDate')) {
			$date3 = str_replace('/', '-', $this->input->post("toDate"));
			$toDate =   date( "Y-m-d", strtotime($this->input->post("toDate")));
		}elseif ($toDate != "NIL") {
			$toDate	=	$toDate;
		} else {
			$toDate	= 'NIL';
		}

		if (@$this->input->post('filter_division')) {
			$filter_division =   $this->input->post("filter_division");
		}elseif ($filter_division != "NIL") {
			$filter_division	=	$filter_division;
		} else {
			$filter_division	= "NIL";
		}
		
		if (@$this->input->post('client_id')) {
			$client_id =   $this->input->post("client_id");
		}elseif ($client_id != "NIL") {
			$client_id	=	$client_id;
		} else {
			$client_id	= "NIL";
		}
		if (@$this->input->post('filter_value')) {
			$filter_value =   $this->input->post("filter_value");
		}elseif ($filter_value != "NIL") {
			$filter_value	=	$filter_value;
		} else {
			$filter_value	= "NIL";
		}
		if (@$this->input->post('qtnNo')) {
			$qtnNo =   $this->input->post("qtnNo");
		}elseif ($qtnNo != "NIL") {
			$qtnNo	=	$qtnNo;
		} else {
			$qtnNo	= "NIL";
		}
          
		
		$sql=' where 1';
		
		if(@$filter_division!="NIL") {
			$sql.=" and FI.quotation_divisionid='$filter_division'";
		} 
		if($filter_value!="NIL"){
			$sql.=" and FI.invoice_number like '%$filter_value%'";
		}
		if($client_id!='NIL') {
			$sql.=" and FI.client_id='$client_id'";
		}

		if($fromDate!='NIL' and $toDate!='NIL') {
			$sql .="  AND FI.`invoice_date` between '$fromDate' and '$toDate'  ";
		} else if($fromDate!='NIL' and $toDate=='NIL'){
			$sql .=" and FI.`invoice_date`	>=	'$fromDate' ";
		} else if($fromDate=='NIL' and $toDate!='NIL'){
			$sql .=" and FI.`invoice_date`	<=	'$toDate' ";
		}

		if($qtnNo!="NIL"){
			$sql.=" and FQ.quotation_number_full like '%$qtnNo%'";
		}
		
		//$data12	=	$this->db->query("SELECT invoice_id FROM `furniture_invoice` FI INNER JOIN `company_division` CD ON CD.division_id = FI.quotation_divisionid LEFT JOIN `new_client_master` NCM ON NCM.client_id = FI.client_id LEFT JOIN `furniture_quotation` FQ ON  FQ.id = FI.quotation_id  ".$sql." ");
		
		$config['uri_segment'] = 3;
        //$config['use_page_numbers'] = TRUE;
		$config['base_url'] = base_url() . "index.php/invoices/index/".$fromDate."/".$toDate."/".$quotation_id.'/'.$filter_division.'/'.$client_id.'/'.$filter_value;
        //$config["total_rows"] = $data12->num_rows();
		$config["total_rows"] = 250;
		if(isset($_POST["ttttt"])) {
			$config['num_links'] = 10;
			$config["per_page"] = 10000000000000;
			$this->pagination->initialize($config);
			$page = 0;
			$i=1;
		} else {
			$config['num_links'] = 10;
			$config["per_page"] = 250;
			$this->pagination->initialize($config);
			if ($this->uri->segment(9)) {
				$page = $this->uri->segment(9)*250-250;
				$i=$page+1;
			} else {
				$page = 0;
				$i=1;
			}
		}

		
		$data1				=	$this->db->query("SELECT * FROM `furniture_invoice` FI INNER JOIN `company_division` CD ON CD.division_id = FI.quotation_divisionid LEFT JOIN `new_client_master` NCM ON NCM.client_id = FI.client_id LEFT JOIN `furniture_quotation` FQ ON  FQ.id = FI.quotation_id ".$sql." ORDER BY FI.`invoice_date` DESC limit ".$page.",".$config["per_page"]);
		$records['invoices']	=	$data1->result_array();
		$this->pagination->initialize($config);
		$records['pagination'] = $this->pagination->create_links();
		
		$records['filter_division']	=	$filter_division;
		$records['client_id']	=	$client_id;
		if($filter_value==='NIL'){
			$filter_value='';
		}
		$records['filter_value']	=	$filter_value;
		$records['toDate']			=	$toDate;
		$records['fromDate']		=	$fromDate;
		$records['qtnNo']			=	$qtnNo;
		
		$this->load->view('templates/header',$title);
		$this->load->view('manage/invoice',$records);
		$this->load->view('templates/footer');
	}

	public function create($id){
		$title['headerTitle']="Invoice Create";
		$this->load->model('proforma_model');
		$data['h1']=$this->proforma_model->pinvoice_getonerow($id);
		$job_card_id = $data['h1']->job_card_id;
		$quotation_divisionid = $data['h1']->quotation_divisionid;
		$invtype=1;
		$data['invoice_no']=$this->proforma_model->get_invoice_no($quotation_divisionid,$invtype);
		$data['sum']=$this->proforma_model->pinvoice_get_sum_amount($job_card_id);
		$data['h']=$this->proforma_model->group_pinvoice_details($id);
		$this->load->view('templates/header',$title);
		$this->load->view('furniture/quotations/createpinvoice',$data);
		$this->load->view('templates/footer');
	}

	public function pupdate($id){
		//$id = $this->input->post('invid');
		$proforma_id = $this->input->post('invid');
		$this->db->trans_begin();
		$query_data= $this->db->query("SELECT * FROM `furniture_invoice` WHERE ( invoice_status='0' ) and `proforma_id`='$proforma_id' ");
		if ($query_data->row()==false){
			$this->load->model('proforma_model');
			$this->proforma_model->pupdate($id);
			if ($this->db->trans_status() === FALSE) {
				$this->db->trans_rollback();
				//$this->session->set_flashdata('response', 'Some Created...');
				redirect('Invoices/create/'.$id);
			} else {
				$this->db->trans_commit();
				$this->session->set_flashdata('success', 'Invoice created successfully...');
				redirect('Invoices');
			}
		} else {
			$this->db->trans_rollback();
			$this->session->set_flashdata('response', 'Already created...');
			redirect('Invoices/create/'.$id);
		}
	}
	public function delete($id,$invoice_number,$proforma_id=NULL){
		$this->load->model('invoice_model');
		$this->db->trans_begin();
		$this->invoice_model->delete($id,$invoice_number,$proforma_id);
		if ($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();
			$this->session->set_flashdata('response', 'something went wrong please try again...');
			redirect('invoices');
		} else {
			$this->db->trans_commit();
			$this->session->set_flashdata('success', 'Invoice Cancelled...');
			redirect('invoices');
		}
	}
}

?>