<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class PL_report extends CI_Controller {

	public function __construct() {
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','Unauthorised access. Login required.');
			redirect('login');
		}
		$this->load->library('form_validation');
		//$this->load->library('pagination');
		$this->load->model('furniture_quotation_model');
	}

	public function test($status='') {
		if($status == "result" ) {
			$this->form_validation->set_rules('report_date_from', 'Date', 'callback_date_check');
			$this->form_validation->set_rules('report_date_to', 'Date', 'callback_date_check');
			
			$error_flag = false;
			$error_msg = '';
			$quotation_type = "furniture";
			
			if ($this->form_validation->run() == FALSE || $error_flag) {
				// false section
				$this->session->set_flashdata('response',''.validation_errors().$error_msg.'',':old:');
				$data['records'] = false;
			} else {
				$data['records']=false;
				$data['quotation_type'] = "furniture";
				$where = array();
				$sql='';
				if($this->input->post('report_date_from') != '' or $this->input->post('report_date_to') != '' ) {
					$date_fmt= date('Y-m-d',strtotime($this->input->post('report_date_from')));
					$date_to= date('Y-m-d',strtotime($this->input->post('report_date_to')));
	
					if($this->input->post('report_date_from')!='' and $this->input->post('report_date_to')!='') {
						$sql=" and ( acc.vch_date >= '$date_fmt' and acc.vch_date<='$date_to' ) ";
					}
					else if($this->input->post('report_date_from') != '') {
						$sql=" and ( acc.vch_date >= '$date_fmt' ) ";
					}
					else if($this->input->post('report_date_to')!=''){
						$sql=" and ( acc.vch_date<='$date_to' ) ";
					}
				}

				$books_beginning_date_config = $this->furniture_quotation_model->books_beginning_date_config();
				if($date_fmt==$books_beginning_date_config){
					$sql=("SELECT acc.ledger_code,led.ledger_name,SUM(CASE WHEN vch_type = 'opening' THEN ledger_amount ELSE 0 END) AS opening_balance,led.acoount_group_id,acc_group_parent,is_revenue FROM `accounts` acc inner JOIN ledgers led on led.ledger_code = acc.ledger_code inner join account_group ag on led.acoount_group_id = ag.acc_group_id where acc.status = 1 and (acc_group_primary = 3 or acc_group_primary = 4) ".$sql." group by acc.ledger_code ORDER BY `led`.`ledger_name` ASC");
					$rs = $this->db->query($sql);
					$data['records']=$rs->result_array();
				} else {
					$sql=("SELECT acc.ledger_code,led.ledger_name,SUM(CASE WHEN vch_type = 'opening' THEN ledger_amount ELSE 0 END) AS opening_balance,led.acoount_group_id,acc_group_parent,is_revenue FROM `accounts` acc inner JOIN ledgers led on led.ledger_code = acc.ledger_code inner join account_group ag on led.acoount_group_id = ag.acc_group_id where acc.status = 1 and (acc_group_primary = 3 or acc_group_primary = 4)  and acc.vch_date >= '$books_beginning_date_config' group by acc.ledger_code ORDER BY `led`.`ledger_name` ASC");
					$rs = $this->db->query($sql);
					$data['records']=$rs->result_array();
				}

				$where_in_values = array(3, 4);
				$this->db->select('*');
				$this->db->from('account_group');
				$this->db->where_in('acc_group_primary', $where_in_values);
				$this->db->where('affects_gross_profit', 'Yes');
				$this->db->order_by("affects_gross_profit", "ASC");
				$this->db->order_by("acc_group_primary", "ASC");
				$this->db->order_by("acc_group_parent", "ASC");
				$this->db->order_by("sort_option", "ASC"); 
				$rs = $this->db->get();
				$data['gross_profit_yes_records'] = $rs->result_array();

				$this->db->select('*');
				$this->db->from('account_group');
				$this->db->where_in('acc_group_primary', $where_in_values);
				$this->db->where('affects_gross_profit', 'No');
				$this->db->order_by("affects_gross_profit", "ASC");
				$this->db->order_by("acc_group_primary", "ASC");
				$this->db->order_by("acc_group_parent", "ASC");
				$this->db->order_by("sort_option", "ASC"); 
				$rs = $this->db->get();
				$data['gross_profit_no_records'] = $rs->result_array();

				if($data['records'] != false) {
					foreach($data['records'] as $record){
						$opening_balance = 0;
						$debit = 0;
						$Credit = 0;
						$Closing = 0;
						if ($this->input->post('report_date_from')){
							$date_fmt= date('Y-m-d',strtotime($this->input->post('report_date_from')));
							$books_beginning_date_config = $this->furniture_quotation_model->books_beginning_date_config();


							if($this->input->post('report_date_from') != '' or $this->input->post('report_date_to') != '' ) {
								$date_fmt= date('Y-m-d',strtotime($this->input->post('report_date_from')));
								$date_to= date('Y-m-d',strtotime($this->input->post('report_date_to')));
				
								if($this->input->post('report_date_from')!='' and $this->input->post('report_date_to')!='') {
									$sql=" and ( acc.vch_date >= '$date_fmt' and acc.vch_date<='$date_to' ) ";
								}
								else if($this->input->post('report_date_from') != '') {
									$sql=" and ( acc.vch_date >= '$date_fmt' ) ";
								}
								else if($this->input->post('report_date_to')!=''){
									$sql=" and ( acc.vch_date<='$date_to' ) ";
								}
							}

							if($date_fmt!=$books_beginning_date_config){
								$opsql=("SELECT acc.ledger_code,led.ledger_name,SUM(ledger_amount) AS opening_balance FROM `accounts` acc inner JOIN ledgers led on led.ledger_code = acc.ledger_code inner join account_group ag on led.acoount_group_id = ag.acc_group_id where acc.status = 1 and acc.`vch_type`!='OPENING' and acc.vch_date < '$date_fmt' and acc.ledger_code='".$record['ledger_code']."' ");
								$oprs = $this->db->query($opsql);
								if($oprs->num_rows()>0){
									$opening_balance = $oprs->row()->opening_balance;
								} else {
									$opening_balance = 0;
								}
							} else {
								$opening_balance = 0;
							}

							$sql3=("SELECT acc.ledger_code,led.ledger_name, led.opening_balance, if(acc.ledger_amount > 0, Round(sum(acc.ledger_amount),3),0) as debit, if(acc.ledger_amount < 0, Round(sum(acc.ledger_amount),3),0) as Credit, Round(sum(acc.ledger_amount),3) as Amount, (led.opening_balance+ Round(sum(acc.ledger_amount),3)) as Closing, ag.acc_group_parent,ag.acc_group_name, if(ag.acc_group_parent=0, ag.acc_group_id , ag.acc_group_parent) as sort FROM `accounts` acc inner JOIN ledgers led on led.ledger_code = acc.ledger_code inner join account_group ag on led.acoount_group_id = ag.acc_group_id where acc.vch_type!='OPENING' AND  acc.status = 1 AND acc.vch_type!='OPENING' AND acc.ledger_code='".$record['ledger_code']."' and acc.ledger_amount > 0 ".$sql." group by acc.ledger_code");
							$rs = $this->db->query($sql3);
							
							if($rs->num_rows()>0){
								$debit = $rs->row()->debit;
								$Closing = $rs->row()->Closing;
							}
							$sql2=("SELECT acc.ledger_code,led.ledger_name, led.opening_balance, if(acc.ledger_amount > 0, Round(sum(acc.ledger_amount),3),0) as debit, if(acc.ledger_amount < 0, Round(sum(acc.ledger_amount),3),0) as Credit, Round(sum(acc.ledger_amount),3) as Amount, (led.opening_balance+ Round(sum(acc.ledger_amount),3)) as Closing, ag.acc_group_parent,ag.acc_group_name, if(ag.acc_group_parent=0, ag.acc_group_id , ag.acc_group_parent) as sort FROM `accounts` acc inner JOIN ledgers led on led.ledger_code = acc.ledger_code inner join account_group ag on led.acoount_group_id = ag.acc_group_id where acc.vch_type!='OPENING' AND  acc.status = 1 AND acc.vch_type!='OPENING' AND acc.ledger_code='".$record['ledger_code']."' and acc.ledger_amount < 0 ".$sql." group by acc.ledger_code");
							$rs2 = $this->db->query($sql2);
							if($rs2->num_rows()>0){
								$Credit = $rs2->row()->Credit;
								$Closing = $rs2->row()->Closing;
							}
							
							$sss[$record['ledger_code']] = array(
								'acc_group_id' => $record['acoount_group_id'],
								'ledger_code' => $record['ledger_code'],
								'ledger_name' => $record['ledger_name'],
								'opening_balance' => $record['opening_balance']+$opening_balance,
								'debit' => $debit,
								'credit' => $Credit,
								'closing_balance' => $record['opening_balance']+$opening_balance+$debit+$Credit,
								'date_fmt' => $date_fmt,
								'date_to' => $date_to,
								'nbxacc_group_parent' => $record['acc_group_parent'],
								'is_revenue' => $record['is_revenue'],
							);
						}			
					} 			
				}
				/* foreach ($data['parent_group_records'] as $item) {
					$sss[$item['acc_group_id']] = $item;
				}*/
				$data['records'] =	$sss;
			}
			
		} else {
			$data['logo_filename']= NULL;
			$data['sales_man'] = NULL;
			$data['records'] = "";
			$data['parent_group_records'] = "";
			$data['sss'] = "";
			$data['quotation_type'] = "furniture";
		}			
						
		$records = $this->crud_model->get('users');
		if($records!=false){
			$division_list = $this->crud_model->get_list('division_id','division_name','company_division',array('select'=>' - Select Division - '));
			$data['division_list'] = $division_list;

			$list = array(0 => ' - Select Salesman - ');
			foreach($records as $record){
				$list[$record['user_id']] = $record['user_name'];
			}
			$data['users'] = $list;
			$data['quotation_status'] = $this->config->item('quotation_status_array');

			$query = $this->db->get('company_details');  
			$data['company_details'] = $query->row_array();
			
			$data=$data;
			
			$this->load->view('templates/header');
			$this->load->view('reports/pl_report',$data);
			$this->load->view('templates/footer');
		}
	}
	
	function date_check($data) {
		$given_date = strtotime($data);
		$today_date = strtotime(date('Y-m-d'));
		if($given_date <= $today_date) {
			return true;
		}else{
			$this->form_validation->set_message('date_check', 'Date cannot be Future date');
			return FALSE;
		}
	}
}

?>