<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Search extends CI_Controller {

	public function __construct() {
		parent::__construct();

		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','Unauthorised access. Login required.');
			redirect('login');
		}

	}


	public function unApprovedPos() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->unApprovedPos(10,0,$search_item);
		$list='<thead class="thead-light">
					<tr>
						<th>PO No.</th>
						<th>PO Date</th>
						<th>Username</th>
						<th>Action</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->po_code.'</td>
					<td>'.date("M d, Y", strtotime($row->po_date)).'</td>
					<td>'.$row->user_name.'</td>
					<td><a href="'.base_url().'index.php/furniture/PurchaseOrder/printPurchaseOrder/'.$row->po_id.'"  target="_blank" >View</a></td>
				</tr>';
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">No records available</td></tr>';
		}
		echo json_encode($list);
	}

	public function todayApprovedPo() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->todayApprovedPo(10,0,$search_item);
		$list=	'<thead class="thead-light">
					<tr>
						<th>PO No.</th>
						<th>PO Date</th>
						<th>Approved User</th>
						<th>Action</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->po_code.' </td>
					<td>'.date("M d, Y", strtotime($row->po_date)).'</td>
					<td>'.$row->approved_user.'</td>
					<td><a href="'.base_url().'index.php/furniture/PurchaseOrder/printPurchaseOrder/'.$row->po_id.'"  target="_blank" >View</a></td>
				</tr>';
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">
			No records available
		</td></tr>';
		}
		echo json_encode($list);
	}
	public function thisWeekApprovedPo() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->thisWeekApprovedPo(10,0,$search_item);
		$list=	'<thead class="thead-light">
					<tr>
						<th>PO No.</th>
						<th>PO Date</th>
						<th>Approved User</th>
						<th>Approved Date</th>
						<th>Action</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->po_code.'</td>
					<td>'.date("M d, Y", strtotime($row->po_date)).'</td>
					<td>'.$row->approved_user.'</td>
					<td>'.date("M d, Y", strtotime($row->approved_date)).'</td>
					<td><a href="'.base_url().'index.php/furniture/PurchaseOrder/printPurchaseOrder/'.$row->po_id.'"  target="_blank" >View</a></td>
				</tr>';
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">
			No records available
		</td></tr>';
		}
		echo json_encode($list);
	}

	public function newJobCards() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->newJobCards();
		$list='<thead class="thead-light">
					<tr>
						<th>Job No.</th>
						<th>Date</th>
						<th>Client</th>
						<th>Project</th>
						<th>Action</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->job_card_number.'</td>
					<td>'.date("M d, Y", strtotime($row->job_card_date)).'</td>
					<td>'.$row->client_name.'</td>
					<td>'.$row->project_name.'</td>
					<td><a class="btn btn-sm btn-primary" href="javascript:jobCardAcknowledge('.$row->id.')" >Acknowledge</a></td>
				</tr>';
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">No records available</td></tr>';
		}
		echo json_encode($list);
	}

	public function acknowledgedJobCard() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->acknowledgedJobCards();
		$list='<thead class="thead-light">
					<tr>
						<th>Job No.</th>
						<th>Date</th>
						<th>Client</th>
						<th>Project</th>
						<th>Acknowledged By</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->job_card_number.'</td>
					<td>'.date("M d, Y", strtotime($row->job_card_date)).'</td>
					<td>'.$row->client_name.'</td>
					<td>'.$row->project_name.'</td>
					<td>'.$row->acknowledge_by.'</td>
				</tr>';
				//<td><a href="'.site_url('jobcard/Job_card/printJobCard/'.$row->id.'/pdf/without_image/0/0/0').'" >Print</a></td>
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">No records available</td></tr>';
		}
		echo json_encode($list);
	}

	public function runningJobCard() {
		$search_item = @$this->input->post('search_item');
		$test=$this->furniture_quotation_model->runningJobCards();
		$list='<thead class="thead-light">
					<tr>
						<th>Job No.</th>
						<th>Date</th>
						<th>Client</th>
						<th>Project</th>
					</tr>
				</thead>';
		if($test!=false){
			$count=0;
			foreach($test as $row){
				$count++;
				$list.='<tr>
					<td>'.$row->job_card_number.'</td>
					<td>'.date("M d, Y", strtotime($row->job_card_date)).'</td>
					<td>'.$row->client_name.'</td>
					<td>'.$row->project_name.'</td>
				</tr>';
				//<td><a href="'.site_url('jobcard/Job_card/printJobCard/'.$row->id.'/pdf/without_image/0/0/0').'" >Print</a></td>
			}
		} else {
			$list.='<tr><td colspan="3" style="color: red;">No records available</td></tr>';
		}
		echo json_encode($list);
	}


	public function search_main_category() {
		$main_category	=	$this->input->post('main_category');
		$today	=	date("Y-m-d");
		$html	='';
		$main_category_data = $this->db->query("SELECT * FROM `main_category` where status='1' and  `category_name` like '%$main_category%' order by category_name");
		$n = 1;

		if (count($main_category_data->result_array()) > 0) {
			foreach ($main_category_data->result_array() as $main_category_datas) {
				$html .= '<li value="' . $main_category_datas['id'] . '" class="main_category_button" tabindex="' . $n++ . '" ><input type="hidden" class="category_name" value="' . $main_category_datas['category_name'] . '" />' . $main_category_datas['category_name'] . '</li>';
			}
		} else {
			$html .= '<li style="color:red;" class="no_result_button" > No Results Found </li>';
		}
		print $html;
	}

	public function search_stock_group()
	{
		$stock_group_name = $this->input->post('stock_group_name');
		$today = date("Y-m-d");
		$html = '';
		$stock_group_data = $this->db->query("SELECT * FROM `stock_group` where status='1' and  `stock_group_name` like '%$stock_group_name%' order by stock_group_name");
		$n = 1;
		if (count($stock_group_data->result_array()) > 0) {
			foreach ($stock_group_data->result_array() as $stock_group_datas) {
				$html .= '<li value="' . $stock_group_datas['id'] . '" class="stock_group_name_button" tabindex="' . $n++ . '" ><input type="hidden" class="stock_group_name" value="' . $stock_group_datas['stock_group_name'] . '" />' . $stock_group_datas['stock_group_name'] . '</li>';
			}
		} else {
			$html .= '<li style="color:red;" class="no_result_button" > No Results Found </li>';
		}
		print $html;
	}
	public function search_brand()
	{
		$brand_name = $this->input->post('brand_name');
		$today = date("Y-m-d");
		$html = '';
		$brand_data = $this->db->query("SELECT * FROM `furniture_brands` where status='1' and `brand_name` like '%$brand_name%' order by brand_name");
		$n = 1;
		if (count($brand_data->result_array()) > 0) {
			foreach ($brand_data->result_array() as $brand_datas) {
				$html .= '<li value="' . $brand_datas['brand_id'] . '" class="brand_button" tabindex="' . $n++ . '" ><input type="hidden" class="brand_name" value="' . $brand_datas['brand_name'] . '" />' . $brand_datas['brand_name'] . '</li>';
			}
		} else {
			$html .= '<li style="color:red;" class="no_result_button" > No Results Found </li>';
		}
		print $html;
	}




}

/* End of file home.php */
/* Location: ./application/controllers/home.php */
