<?php
require_once APPPATH . "/third_party/ocr/src/TesseractOCR/TesseractOCR.php";
//require_once dirname(__FILE__).'/ocr/src/TesseractOCR.php';

use Wangoviridans\TesseractOCR\TesseractOCR;

class TesseractOCRTest extends CI_Controller
{
	protected $imagesDir;

	public function __construct(){
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','Unauthorised access. Login required.');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->library('pagination');
		$this->load->helper('text');
		$this->config->load('arrays');
	}

	public function setUp()
	{
		$this->imagesDir = dirname(__FILE__) . DIRECTORY_SEPARATOR;
		$this->imagesDir.= 'images'.DIRECTORY_SEPARATOR;
	}

	public function testBasicRecognition()
	{
		$tesseract = new TesseractOCR(array(
			'file.input' => "{$this->imagesDir}hello.png"
		));
		$expectedText = 'Hello Tesseract OCR, welcome to PHP';
		$this->assertEquals($expectedText, $tesseract->recognize());
	}

	public function testInducedRecognition()
	{
		$tesseract = new TesseractOCR(array(
			'file.input' => "{$this->imagesDir}gotz.png"
		));
		$tesseract->setWhitelist(range(0,9));
		$this->assertEquals(6012, $tesseract->recognize());
	}

	public function testSpecificLanguageRecognition()
	{
		$tesseract = new TesseractOCR(array(
			'file.input' => "{$this->imagesDir}german.png"
		));
		$tesseract->setLanguage('deu');
		$this->assertEquals('grüßen in Deutsch', $tesseract->recognize());
	}
}