<?php
class Payhead extends CI_Controller {
	public function __construct(){
		parent::__construct();
		if($this->session->userdata('user_logged_in') != true)
		{
			$this->session->set_flashdata('response','Unauthorised access. Login required.');
			redirect('login');
		}
		$this->load->library('form_validation');
		$this->load->library('pagination');
		$this->load->helper('text');
		$this->config->load('arrays');
	}
	function index($page=1)	{
		$title['headerTitle']="Pay head List";
		$config['per_page']		= 100;
		$config['base_url'] 	= site_url('masters/Payhead/index/');
		$config['total_rows'] 	= $this->crud_model->get_count('pay_head',array());

		$offset = ($page-1) * $config['per_page'];

		$data['records'] = $this->crud_model->get('pay_head',array(),$config['per_page'],$offset,'id','DESC');
		
		$this->pagination->initialize($config);
		$data['pagination'] = $this->pagination->create_links();

		$this->load->view('templates/header',$title);
		$this->load->view('masters/payhead/list',$data);
		$this->load->view('templates/footer');
	}
	function create() {
		$title['headerTitle']="Pay head Create";
		$this->load->view('templates/header',$title);
		$this->load->view('masters/payhead/create');
		$this->load->view('templates/footer');
	}
	function test(){}
	function edit($id) {
		$title['headerTitle']="Pay head Edit";
		$where=array(
			'id' => $id
		);
		$records=$this->crud_model->get('pay_head',$where);
		if($records != false){
			//true section
			$data['id']				= $records[0]['id'];
			$data['pay_head_name']	= $records[0]['pay_head_name'];
			$data['by_attendance']	= $records[0]['by_attendance'];
			$data['is_gosi']		= $records[0]['is_gosi'];
			$data['is_indemnity']	= $records[0]['is_indemnity'];
			$data['is_leave_salary']= $records[0]['is_leave_salary'];
			$data['is_loan']		= $records[0]['is_loan'];
			$data['is_ot_normal']	= $records[0]['is_ot_normal'];
			$data['is_ot_special']	= $records[0]['is_ot_special'];
			$data['status']			= $records[0]['status'];
			$data['user_status'] 	= $this->config->item('user_status_array');

			$this->load->view('templates/header',$title);
			$this->load->view('masters/payhead/edit',$data);
			$this->load->view('templates/footer');

		} else {
			//false section
			$this->session->set_flashdata('response','error');
			redirect('masters/Payhead');
		}
	}
	function do_insert() {
		$title['headerTitle']="Pay head Create";
		$this->form_validation->set_rules('pay_head_name', 'Name', 'required');
		
		if ($this->form_validation->run() == FALSE) {
			// false section
			$this->session->set_flashdata('response',''.validation_errors().'',':old:');
			$this->load->view('templates/header',$title);
			$this->load->view('masters/payhead/create');
			$this->load->view('templates/footer');
		} else {	
			// true section
			$pay_head_name=$this->input->post('pay_head_name');
			if($this->input->post('by_attendance')!='') {
				$by_attendance=1;
			} else {
				$by_attendance=0;
			}
			if($this->input->post('is_gosi')!='') {
				$is_gosi=1;
			} else {
				$is_gosi=0;
			}
			if($this->input->post('pay_head_type')==='Is Indemnity') {
				$is_indemnity=1;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is Leave Salary') {
				$is_indemnity=0;
				$is_leave_salary=1;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is Loan') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=1;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is OT Normal') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=1;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is OT Special') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=1;
			}
			
			$data=array(
				'pay_head_name' => $pay_head_name,
				'by_attendance' => $by_attendance,
				'is_gosi' => $is_gosi,
				'is_indemnity' => $is_indemnity,
				'is_leave_salary' => $is_leave_salary,
				'is_loan' => $is_loan,
				'is_ot_normal' => $is_ot_normal,
				'is_ot_special' => $is_ot_special
			);

			$rr=$this->crud_model->insert('pay_head',$data);
			$insert_id	=	$this->db->insert_id();
			$date = date("Y-m-d H:i:s");
			$userid = $this->session->userdata('user_id');
			$data= array(						
				'masters_type'=>'Payroll Payhead',	
				'masters_id'=>$insert_id,	
				'date'=>$date,	
				'created_id'=> $userid,	
				'masters_op'=>'create',	
			);
			$this->crud_model->insert('log_for_masters',$data);

			if($rr == false) {
				// error
				$this->session->set_flashdata('response','Pay head cannot be inserted',':old:');
				$redirect('masters/Payhead');
			} else {
				// redirect
				$this->session->set_flashdata('success','Pay head added successfully');
				redirect('masters/Payhead');
			}
		}
	}

	function do_update() {
		$title['headerTitle']="Department Edit";
		$pay_head_id = ascii_to_entities($this->input->post('pay_head_id'));
		$this->form_validation->set_rules('pay_head_name', 'Name', 'required');
		$status = ascii_to_entities($this->input->post('status'));
		$file_error = "";
		$filename = "";
	
		if ($this->form_validation->run() == FALSE) {
			// false section
			$where=array("id"=>$pay_head_id);
			$records=$this->crud_model->get('pay_head', $where);
			if($records != false){
				//true section
				$data['id']				= $records[0]['id'];
				$data['pay_head_name']	= $records[0]['pay_head_name'];
				$data['by_attendance']	= $records[0]['by_attendance'];
				$data['is_gosi']		= $records[0]['is_gosi'];
				$data['is_indemnity']	= $records[0]['is_indemnity'];
				$data['is_leave_salary']= $records[0]['is_leave_salary'];
				$data['is_loan']		= $records[0]['is_loan'];
				$data['is_ot_normal']	= $records[0]['is_ot_normal'];
				$data['is_ot_special']	= $records[0]['is_ot_special'];
				$data['status']			= $records[0]['status'];
	
				$data['user_status'] = $this->config->item('user_status_array');

				$this->session->set_flashdata('response',''.validation_errors().'',':old:');
				$this->load->view('templates/header',$title);
				$this->load->view('masters/payhead/edit',$data);
				$this->load->view('templates/footer');

			} 
		} else {// true section
			
			$pay_head_name=$this->input->post('pay_head_name');
			if($this->input->post('by_attendance')!='') {
				$by_attendance=1;
			} else {
				$by_attendance=0;
			}
			if($this->input->post('is_gosi')!='') {
				$is_gosi=1;
			} else {
				$is_gosi=0;
			}
			if($this->input->post('pay_head_type')==='Is Indemnity') {
				$is_indemnity=1;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is Leave Salary') {
				$is_indemnity=0;
				$is_leave_salary=1;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is Loan') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=1;
				$is_ot_normal=0;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is OT Normal') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=1;
				$is_ot_special=0;
			} elseif($this->input->post('pay_head_type')==='Is OT Special') {
				$is_indemnity=0;
				$is_leave_salary=0;
				$is_loan=0;
				$is_ot_normal=0;
				$is_ot_special=1;
			}
			
			$data=array(
				'pay_head_name'  => $pay_head_name,
				'by_attendance'  => $by_attendance,
				'is_gosi' 		 => $is_gosi,
				'is_indemnity'   => $is_indemnity,
				'is_leave_salary'=> $is_leave_salary,
				'is_loan'        => $is_loan,
				'is_ot_normal'   => $is_ot_normal,
				'is_ot_special'  => $is_ot_special
			);
			$where=array(
				'id'  => $pay_head_id
			);
		
			$records=$this->crud_model->update('pay_head',$data,$where);
			$date = date("Y-m-d H:i:s");
			$userid = $this->session->userdata('user_id');
			$data= array(						
				'masters_type'=>'Payroll Payhead',	
				'masters_id'=>$pay_head_id,	
				'date'=>$date,	
				'created_id'=> $userid,	
				'masters_op'=>'update',	
			);
			$this->crud_model->insert('log_for_masters',$data);

			$this->session->set_flashdata('success','Pay head updated');
			redirect('masters/Payhead');
		}
	}
	function do_delete($department_id=0) {

		$where=array(
			'department_id'  => $department_id
		);
		$data=array('status' => 0);
			
		$records=$this->crud_model->update('department_master',$data,$where);
		$date = date("Y-m-d H:i:s");
		$userid = $this->session->userdata('user_id');
		$data= array(						
			'masters_type'=>'Payroll Payhead',	
			'masters_id'=>$pay_head_id,	
			'date'=>$date,	
			'created_id'=> $userid,	
			'masters_op'=>'delete',	
		);
		$this->crud_model->insert('log_for_masters',$data);
		

		$this->session->set_flashdata('success','Department deleted');
		redirect('masters/Department');
	}
}